<?php

include_once('BingMapPro_InstallIndicator.php');
//include_once( 'BingMapPro_OptionsManager.php');
include_once( 'BingMapPro_MasterMaps.php');
include_once( 'BingMapPro_Maps.php' );
include_once( 'BingMapPro_GeneralSettings.php' );
include_once( 'BingMapPro_Pins.php');
include_once( 'BingMapPro_MasterPins.php');

class BingMapPro_LifeCycle extends BingMapPro_InstallIndicator{
    private $bmp_api_key = '';   
    public function install(){
        
        // Initialize Plugin Options
        $this->initOptions();

        // Initialize DB Tables used by the plugin
        $this->installDatabaseTables();

        // Other Plugin initialization - for the plugin writer to override as needed
        $this->otherInstall();

        // Record the installed version
        $this->saveInstalledVersion();

        // To avoid running install() more then once
        $this->markAsInstalled();
    }

    public function uninstall(){
        $this->otherUninstall();
        $this->unInstallDatabaseTables();
        $this->deleteSavedOptions();
        $this->markAsUnInstalled();
    }


    public function upgrade() {
    }


    public function activate() {
    }


    public function deactivate() {
    }


    protected function initOptions() {
    }

    public function addActionsAndFilters() {
    }


    protected function installDatabaseTables() {
    }


    protected function unInstallDatabaseTables() {
    }


    protected function otherInstall() {
    }

  
    protected function otherUninstall() {
    }

    public function addSettingsSubMenuPage() {

        $this->addSettingMenuPageToSettings();
        $this->addSettingsSubMenuPins();
        $this->addSettingsSubMenuSettings();
               
    }
    
    protected function requireExtraPluginFiles() {
        require_once(ABSPATH . 'wp-includes/pluggable.php');
        require_once(ABSPATH . 'wp-admin/includes/plugin.php');
    }

 
    protected function getSettingsSlug() {
        return get_class($this) . 'Settings';
    }
    protected function getSettingsPinsSlug(){
        return get_class($this) . 'Pins';    
    }

    protected function addSettingsSubMenuSettings(){
        global $pw_settings_page;
        $displayName = $this->getSettingsSlug() . '_general_settings';
        $pw_settings_page = add_submenu_page( $this->getSettingsSlug(), 
                            'Settings', 
                            'Settings', 
                            'manage_options', 
                            $displayName, 
                            array( &$this, 'generalSettings'), '', 120 );    
    }

    protected function addSettingsSubMenuPins(){
        global $pw_settings_pins;
        $displayName = $this->getSettingsPinsSlug() . '_general_pins';
        $pw_settings_pins = add_submenu_page( $this->getSettingsSlug(), 
                            'Pins', 
                            'Pins', 
                            'manage_options', 
                            $displayName, 
                            array( &$this, 'bmp_settingPins'), '', 110);    
    }

    protected function addSettingMenuPageToSettings(){
        global $pw_main_page;
        $displayName = $this->getPluginDisplayName();        
        $pw_main_page = add_menu_page(  $displayName,
                        $displayName,
                        'manage_options',
                        $this->getSettingsSlug(),
                        array( &$this, 'showMaps'),
                        plugins_url('/images/icons/plugin-icon.png', __FILE__),
                        200
                        );
    }

    
    public function my_save_error(){
        file_put_contents(dirname(__file__).'/error_activation.txt', ob_get_contents());
    }

    public function bmp_shortcodes_init(){
        global $active_maps;
        global $full_map;
        $maps = new BingMapPro_Map_Full();
        $active_maps = $maps->getActiveMaps();
        $full_map = $active_maps;
      


        if( count( $active_maps ) > 0 ){  // if active maps exist, create shortcode

            function wporg_shortcode($atts = [], $content = null, $tag ){
                global $full_map;
                global $bmp_api_key;
                // do something to $content
                $bmp_full_map = new BingMapPro_Map_Full();
                $bmm = new BingMapPro_OptionsManager();

                foreach( $full_map as $map ){
                    if( $tag == $map->map_shortcode ){
                        global $BMP_PLUGIN_VERSION;                        
                        $bmp_map_pins = $bmp_full_map->getMapAllActivePins( $map->id );
                        $bmp_icon_src = plugins_url('/', __FILE__ );
                        $bmp_encoded_map  = json_encode( $map, true );                        
                        $bmp_map_pins = json_encode( $bmp_map_pins, true );
                        $bmp_map_id = $map->id;

                        //BMP_show_maps
                        $bmp_api_key_local = $bmm->getOption('bmp_api_key', $bmp_api_key );
                        $bmp_map_script = "<div class='test' id='bmp_{$map->map_shortcode}' style='position: relative; width:{$map->map_width}{$map->map_width_type}; height:{$map->map_height}{$map->map_height_type}'                                        
                                        ></div>
                                        <script type='text/javascript' src='https://www.bing.com/api/maps/mapcontrol?key=".$bmp_api_key_local."'></script>
                                        <script type='text/javascript'> 
                                            var bmp_icon_src    = '{$bmp_icon_src}';                                        
                                    
                                            window.addEventListener('load', function(){    
                                                var bmp_map_id = document.getElementById('bmp_{$map->map_shortcode}'); 
                                                var bmp_map_{$bmp_map_id}           = JSON.parse( JSON.stringify( {$bmp_encoded_map} ) );   
                                                var bmp_map_all_pins_{$bmp_map_id}  = JSON.parse( JSON.stringify( {$bmp_map_pins} ) );                                             
                                                bmp_loadMapScenario( bmp_map_id , bmp_map_all_pins_{$bmp_map_id}, bmp_map_{$bmp_map_id} );                                                                                                                                           
                                            });
                                            
                                        </script>";
                       
                        wp_enqueue_script('bmp_map_script_front',  plugins_url('/js/bmp_map_script_front.js'. '?v='.$BMP_PLUGIN_VERSION, __FILE__ ) );
                        return $bmp_map_script;
                    }
                }

              

            }  

            foreach( $active_maps as $map ){                             
                add_shortcode( $map->map_shortcode , 'wporg_shortcode');
            }



        }
       
    }


    protected function prefixTableName($name) {
        global $wpdb;
        return $wpdb->prefix .  strtolower($this->prefix($name));
    }

    public function getAjaxUrl($actionName) {
        return admin_url('admin-ajax.php') . '?action=' . $actionName;
    }

    public function bmp_general_settings() {
        $bmm = new BingMapPro_OptionsManager();
        global $bmp_api_key;
       
        $data =  $_POST['data'];
       
        $data_api_key =  trim( sanitize_text_field( $data['bmp_api_key'] ) );
    //    $data_bmp_dfs = $data['bmp_dfs'];
        $data_bmp_dsom = sanitize_text_field( $data['bmp_dsom'] );
        $data_bmp_cnb = sanitize_text_field( $data['bmp_cnb'] );        
    //    $data_bmp_dsv = $data['bmp_dsv'];
        $data_bmp_dz  = sanitize_text_field( $data['bmp_dz'] );
        $data_bmp_mr  = sanitize_text_field( $data['bmp_mr'] );


        if(! $bmm->addOption('bmp_api_key', $data_api_key ) )
            $bmm->updateOption( 'bmp_api_key', $data_api_key  );

        if(! $bmm->addOption( 'bmp_dsom', $data_bmp_dsom) )
            $bmm->updateOption( 'bmp_dsom', $data_bmp_dsom );
        
        if(! $bmm->addOption( 'bmp_cnb', $data_bmp_cnb ))
            $bmm->updateOption( 'bmp_cnb', $data_bmp_cnb );


        if(! $bmm->addOption('bmp_dz', $data_bmp_dz))
            $bmm->updateOption( 'bmp_dz', $data_bmp_dz );

        if(! $bmm->addOption('bmp_mr', $data_bmp_mr))
            $bmm->updateOption( 'bmp_mr', $data_bmp_mr );

        if( ! isset( $_POST['data'] ) )
            echo json_encode('0');
        else {
            if( strcmp( $bmp_api_key, $data['bmp_api_key'] ) == 0)
                echo json_encode( '3' );
            else
                echo json_encode( '1');      
        }

        wp_die(); 
    }

    public function doMyShortcode(){
        return 'test';
    }

    public function bmp_add_shortcode(){
        return 'this is a test';
    }
    public function bmp_new_map(){
        
        if( isset( $_POST['data']) )
            $map_title = sanitize_text_field( $_POST['data']['map_title'] );
        
        $masterMap = new MasterMaps();

        $arr = $masterMap->mapsToArray();
        echo json_encode( $arr );
    
        wp_die();
    }
    public function bmp_save_map(){
        
        if( isset( $_POST['data'] ) ){
            $fullMap = new BingMapPro_Map_Full(); 
            $data_map =  $_POST['data']; 
            $fullMap->updateFullMap( $data_map  );  //sanitized inside this function, before adding into db
            echo json_encode(  $data_map );
        }
        wp_die();
    }


    public function bmp_map_actions(){

        if( isset( $_POST['data']) ){
            $bmp_map_title  = trim( sanitize_text_field( $_POST['data']['bmp_map_title'] ) );
            $bmp_map_action = sanitize_text_field( $_POST['data']['bmp_map_action'] );
            $bmp_map_id     = (int) sanitize_text_field( $_POST['data']['bmp_map_id'] );
            $masterMaps     = new BingMapPro_MasterMaps();
            $maps           = $masterMaps->getAllMaps(); 

            $arr= [ $bmp_map_action, $bmp_map_id, $bmp_map_title];
            if( $bmp_map_action == 'new'){               
                if( $bmp_map_title !== '' ){                   
                    
                    $bmp_dsom   = $this->getOption( 'bmp_dsom', 'false');
                    $bmp_cnb    = $this->getOption( 'bmp_cnb', 'false' );                
                    $bmp_dz     = $this->getOption( 'bmp_dz', 'false');
                    $bmp_mr     = $this->getOption( 'bmp_mr', 'false');

                    $bmp_extras['dsom'] = $bmp_dsom;
                    $bmp_extras['cnb']  = $bmp_cnb;
                    $bmp_extras['dz']   = $bmp_dz;
                    $bmp_extras['mr']   = $bmp_mr;

                    $bmp_new_map =  $masterMaps->saveNewMap( $bmp_map_title, $bmp_extras );

                    if(  ! is_bool( $bmp_new_map ) ){
                        echo json_encode( $bmp_new_map->mapToArray() );
                    }else{
                       echo  'false';
                    }
                }
                
            }else if( $bmp_map_action == 'edit'){
                array_push( $arr, 'edit');
                echo json_encode( $arr );
            }else if( $bmp_map_action == 'delete'){
                array_push( $arr, 'delete');            
                $masterMaps->deleteMap( $bmp_map_id );
                echo json_encode( $bmp_map_id );
            }else if( $bmp_map_action == 'active' ){
                $new_map = $maps[ $bmp_map_id ];
                $new_map->disableMap(); 
                echo '1';  
            }

        }
             
        wp_die();

    }

    public function showMaps() {
       
        if( ! is_admin() ){
            wp_die(__('You don\'t have sufficient permissions to access this page.', 'bing-map-pro'));
        } 

    ?>
        
        <div class="wrap">
            <?php
                                
                if( isset( $_POST['bmp_page_action']) && ( $_POST['bmp_page_action'] == 'edit-map' ) ){ 
                    $map_id = sanitize_text_field( $_POST['bmp_page_map_id'] );
                    $new_map = new BingMapPro_Map_Full();
                    $bmp_api_key = $this->getOption('bmp_api_key', $this->getDefaultKey() );
                    $bmp_map_pins = $new_map->getMapPinsFull( $map_id );
                    bmp_editMap( $new_map->getFullMap( $map_id ) , $bmp_api_key, $bmp_map_pins );
                }else if( isset( $_POST['bmp_page_action']) && ( $_POST['bmp_page_action'] == 'bmp-add-map-pins') ){
                    $map_id = trim( $_POST['bmp_page_map_id'] );
                    $bmp_api_key = $this->getOption('bmp_api_key', $this->getDefaultKey() );
                    $bmp_api_pin = new BingMapPro_Pin();
                    $bmp_api_all_pins = $bmp_api_pin->getAllPins();
                    $bmp_api_map = new BingMapPro_Map_Full();
                    $bmp_api_map_pins = $bmp_api_map->getMapPins( $map_id );
                    bmp_add_map_pins( $map_id, $bmp_api_key, $bmp_api_all_pins, $bmp_api_map_pins );    
                }else{
                    $allMaps = new BingMapPro_MasterMaps();
                    $allMaps = $allMaps->mapsToArray();
                    $bmp_api_key = $this->getOption( 'bmp_api_key', $this->getDefaultKey() );
                    bmp_maps( $allMaps, $bmp_api_key ); 
                }
            ?>
        
        </div>

    <?php

    }

    public function generalSettings(){
        
        $bmp_api_key = $this->getOption( 'bmp_api_key', $this->getDefaultKey() );
    //    $bmp_dfs    = $this->getOption( 'bmp_dfs', 'false' );
        $bmp_dsom   = $this->getOption( 'bmp_dsom', 'false');
        $bmp_cnb    = $this->getOption( 'bmp_cnb', 'false' );
    //    $bmp_dsv    = $this->getOption( 'bmp_dsv', 'false');
        $bmp_dz     = $this->getOption( 'bmp_dz', 'false');
        $bmp_mr     = $this->getOption( 'bmp_mr', 'false');

        $settings = [];
        $settings['bmp_api_key']    = $bmp_api_key;
    //    $settings['bmp_dfs']        = $bmp_dfs;
        $settings['bmp_dsom']       = $bmp_dsom;
        $settings['bmp_cnb']        = $bmp_cnb;
    //    $settings['bmp_dsv']        = $bmp_dsv;    
        $settings['bmp_dz']         = $bmp_dz;  
        $settings['bmp_mr']         = $bmp_mr;  //map refresh -> update map when changes 
    
        bmp_generalSettings( $settings );        
    }
    private function getDefaultKey(){
        return $this->bmp_api_key;
    }

    public function  bmp_settingPins(){
        $bmp_api_key = $this->getOption( 'bmp_api_key', $this->getDefaultKey() );
        $new_pin = new BingMapPro_Pin();
        $all_pins = $new_pin->getAllPins();
        bmp_init_pins( $all_pins , $bmp_api_key);
    }

    public function bmp_new_pin(){
        $bmp_new_pin = new BingMapPro_Pin();
        if( isset( $_POST['data']) ){            
            $bmp_new_pin->saveNewPin( $_POST['data'] );                     
        }

        $bmp_last_created_pin = $bmp_new_pin->getLastAddedPin();
        if( $bmp_last_created_pin !== null )
            echo json_encode( $bmp_last_created_pin );                         
        else
            echo '0';

        wp_die();
    }

    public function bmp_pin_actions(){

        if( isset( $_POST['data'] ) ){
            $data_action = isset( $_POST['data']['action'] ) ? $_POST['data']['action'] : '' ;
            $bmp_pin = new BingMapPro_Pin();
            if( $data_action === 'disable-pin'){
                $pin_id = (int)sanitize_text_field( $_POST['data']['pin_id']);
                $pin_status = sanitize_text_field( $_POST['data']['status'] );                
                $bmp_result =  $bmp_pin->disableEnablePin( $pin_id, $pin_status );
                echo json_encode( $bmp_result );
            }else if( $data_action === 'delete-pin' ){
                $pin_id = (int)sanitize_text_field( $_POST['data']['pin_id']);
                $bmp_result = $bmp_pin->deletePin( $pin_id ); 
                echo json_encode( $bmp_result );
            }else if( $data_action === 'edit-pin' ){
                $data_pin =  $_POST['data']['pin']; // it is sanitized inside the updatePin function
                $update_result =  $bmp_pin->updatePin( $data_pin  );
                if( $update_result)
                    echo json_encode( $data_pin);
                else 
                    echo $update_result;
            }else if( $data_action === 'add_pin_to_map'){
                $map_id = sanitize_text_field( $_POST['data']['map_id'] );
                $pin_id = sanitize_text_field( $_POST['data']['pin_id'] );
                $map    = new BingMapPro_Map_Full();
                $result = $map->addPinToMap( $map_id, $pin_id );
                $data = array(
                    'result' => $result,
                    'action' => 'add_pin_to_map'
                );
                echo json_encode( $data );
            }else if( $data_action === 'remove_pin_from_map'){
                $map_id = sanitize_text_field( $_POST['data']['map_id'] );
                $pin_id = sanitize_text_field( $_POST['data']['pin_id'] );
                $map    = new BingMapPro_Map_Full();
                $result = $map->removePinFromMap( $map_id, $pin_id );
                $data = array(
                    'result' => $result,
                    'action' => 'remove_pin_from_map'
                );
                echo json_encode( $data );
            }else if( $data_action === 'disable_pin_from_map' ){
                $map_id = sanitize_text_field( $_POST['data']['map_id'] );
                $pin_id = sanitize_text_field( $_POST['data']['pin_id'] );
                $map    = new BingMapPro_Map_Full();
                $result = $map->disablePinFromMap( $map_id, $pin_id );
                $data = array(
                    'result' => $result,
                    'action' => 'disable_pin_from_map'
                );
                echo json_encode( $data );   
            }
            
        }
        

        wp_die();
    }


}


