<?php
class BingMapPro_Pin{

    public function __construct(){}
    
    public function getAllPins(){
        global $wpdb;
        $pins_table = $wpdb->prefix . 'bingmappro_pins';
        $allPins = $wpdb->get_results("SELECT * FROM $pins_table ORDER BY created_at DESC");
        if( count( $allPins) > 0 )
            return $allPins;
        else
            return null;
    }

    public function saveNewPin( $pin_data ){

        $pin_active     = ( sanitize_text_field( $pin_data['active'] ) ) == 'true';
        $pin_name       = sanitize_text_field( $pin_data['name']);
        $pin_address    = sanitize_text_field( $pin_data['address']);       
        $pin_lat        = sanitize_text_field( $pin_data['lat']);
        $pin_long       = sanitize_text_field( $pin_data['long']);
        $pin_icon       = sanitize_text_field( $pin_data['icon']);
        $pin_title      = sanitize_text_field( $pin_data['title']);
        $pin_desc       = sanitize_text_field( $pin_data['desc']);

        global $wpdb;
        $pins_table = $wpdb->prefix . 'bingmappro_pins';

        $wpdb->query( $wpdb->prepare("INSERT INTO $pins_table (active, pin_name, pin_address, pin_lat, pin_long, icon, pin_title, pin_desc)
                                        VALUES ( %d, %s, %s, %s, %s, %s, %s, %s  );", 
                                        $pin_active, $pin_name, $pin_address, $pin_lat, $pin_long, $pin_icon, $pin_title, $pin_desc ) );
     
    }

    public function getLastAddedPin(){
        global $wpdb;
        $pins_table = $wpdb->prefix . 'bingmappro_pins';        
        $bmp_last_created_pin = $wpdb->get_results("SELECT * FROM $pins_table ORDER BY created_at DESC LIMIT 1;");

        if( count( $bmp_last_created_pin ) > 0 ){
            return $bmp_last_created_pin[0];
        }else{
            return null;
        }
    }

    public function disableEnablePin( $pin_id, $value ){
        global $wpdb;
        $pins_table = $wpdb->prefix . 'bingmappro_pins'; 
        return $wpdb->query( $wpdb->prepare("UPDATE $pins_table SET active = %d WHERE id = %d;", $value == 'true', $pin_id ) );
    }
    public function deletePin( $pin_id ){
        global $wpdb;
        $pins_table = $wpdb->prefix . 'bingmappro_pins'; 
                $wpdb->query( $wpdb->prepare( "DELETE FROM {$wpdb->prefix}bingmappro_map_pins WHERE pin_id = %d;", $pin_id ));
        return  $wpdb->query( $wpdb->prepare("DELETE FROM $pins_table WHERE id = %d;",  $pin_id ) );
        
    }
    public function updatePin( $pin_data ){
        $pin_id     = sanitize_text_field( (int)$pin_data['id'] );
        $pin_active = ( sanitize_text_field( $pin_data['active']) ) == '1';
        $pin_name   = sanitize_text_field( $pin_data['pin_name'] );
        $pin_address = sanitize_text_field( $pin_data['pin_address'] );
        $pin_lat    = sanitize_text_field( $pin_data['pin_lat']);
        $pin_long   = sanitize_text_field( $pin_data['pin_long'] );
        $pin_icon   = sanitize_text_field( $pin_data['icon']);
        $pin_title  = sanitize_text_field( $pin_data['pin_title'] );
        $pin_desc   = sanitize_text_field( $pin_data['pin_desc'] );

        global $wpdb;
        $pins_table = $wpdb->prefix . 'bingmappro_pins'; 

        $q_result =  $wpdb->query( $wpdb->prepare( "UPDATE $pins_table SET
                                            active = %d, 
                                            pin_name = %s,
                                            pin_address = %s,
                                            pin_lat = %s, 
                                            pin_long = %s,
                                            icon = %s,
                                            pin_title = %s,
                                            pin_desc = %s 
                                            WHERE id = %d;", $pin_active, $pin_name, $pin_address, $pin_lat, $pin_long, $pin_icon, $pin_title, $pin_desc, $pin_id ) );

        return $q_result;                                        

    }

}