/* Pins javascript */
var bmp_bing_map_pins, bmp_new_pin;
var bmpX = jQuery.noConflict();
bmpX(function(bmpX){

    bmpX('#bmp_new_pin_icon').on('change', function(){                 
        var pinVal =  bmpX('#bmp_new_pin_icon option:selected').val();       
        bmpX('#pin_icon_img img').attr('src', bmpIconsDefaultUrl + 'pin-' + pinVal + '.png');
      
       var bmp_pin_obj =  bmp_get_pin_data();
       bmp_show_pin_on_map( bmp_pin_obj );
    })

    //===============================================
    /* Pins page */

    bmpX('#bmp_new_pin img').on('click', function(){
        var imgSrc = bmpX(this).attr('src');
        imgSrc = imgSrc.split('/');
        if( bmpX('.new-pin-block').is(':visible') ){
            imgSrc[ imgSrc.length-1 ] = 'expand.png';
            bmpX( this ).attr('src', imgSrc.join('/') );
            bmpX('.new-pin-block').slideUp();
            bmpX('.new-pin-block').removeClass('show-new-pin-block');  
        }else{
            imgSrc[ imgSrc.length-1 ] = 'collapse.png';
            bmpX( this ).attr('src', imgSrc.join('/') );
            bmpX('.new-pin-block').slideDown(); 
            bmpX('.new-pin-block').addClass('show-new-pin-block');  
        }
    });


    bmpX('#bmp_new_pin_name').on('keyup', function(){
        if( bmpX(this).val().trim().length > 0 ){
            bmpX(this).removeClass('required_input');
        }else{
            bmpX(this).addClass('required_input'); 
        }
    });
    bmpX('#bmp_new_pin_lat').on('keyup', function(){
        if( bmpX(this).val().trim().length > 0 ){
            bmpX(this).removeClass('required_input');
        }else{
            bmpX(this).addClass('required_input'); 
        }
    });
    bmpX('#bmp_new_pin_long').on('keyup', function(){
        if( bmpX(this).val().trim().length > 0 ){
            bmpX(this).removeClass('required_input');
        }else{
            bmpX(this).addClass('required_input'); 
        }
    });

    bmpX('#bmp_btn_del_pin').on('click', function(){
        var $pin_id =  bmpX('#bmp_pin_hidden_pin_id').val();
        var data = {
            action : 'delete-pin',
            pin_id : $pin_id 
        }
        bmp_pin_action( data );
    });

    bmpX('#bmp_view_new_pin').on('click', function(){ 
        var bmp_pin_obj =  bmp_get_pin_data();
        bmp_show_pin_on_map( bmp_pin_obj );
    }); 


    bmpX('#bmp_cancel_edit_pin').on('click', function(){
        bmpX(this ).hide();
        bmp_clear_pin_inputs('new');
        bmpX('#pin_action_id').val('');
        bmpX('#pin_action').val('new-pin');
        bmp_bing_map_pins.entities.clear();
    });
    
    RefreshMapPin();

    bmpX('[data-toggle="tooltip"]').tooltip();  

});

function bmp_modal_ok_edit_pin(el ){
    var pin_id =  bmpX(el).attr('data-id');
    bmpX('#pin_action_id').val(pin_id);
    bmpX('#pin_action').val('edit-pin');
    bmp_show_edited_pin( pin_id  ); 
}


function pushpinClicked(e) {
    //Make sure the infobox has metadata to display.
    if (e.target.metadata) {
        //Set the infobox options with the metadata of the pushpin.
        infobox.setOptions({
            location: e.target.getLocation(),
            title: e.target.metadata.title,
            description: e.target.metadata.description,
            visible: true
        });
    }
}

function bmp_clear_pin_inputs( action ){
    bmpX('#bmp_new_pin_name').val('');
    bmpX('#bmp_new_pin_address').val('');
    bmpX('#bmp_new_pin_lat').val('');
    bmpX('#bmp_new_pin_long').val('');
    bmpX('#bmp_new_pin_icon option').prop('selected', false );
    if( action === 'new' ){
        bmpX('#bmp_new_pin_icon option:first').prop('selected', true );
        bmpX('#pin_icon_img img').attr('src', bmpIconsDefaultUrl + 'pin-0.png');
    }
    bmpX('#bmp_new_pin_title').val('');
    bmpX('#bmp_new_pin_description').val('');   
}

function BmpCreatePinRow( bmp_pin_obj, obj_to_prepend, action='prepend' ){
    var $pin_id, $pin_name, $pin_address, $pin_lat, $pin_long, $pin_icon, $pin_desc;
    if( bmp_pin_obj !== null ){        
        $pin_id         = bmp_pin_obj.id;
       
        $pin_name       = bmp_pin_obj.pin_name;

        $pin_name       = $pin_name.replace(/\\/g, '' );
        $pin_address    = bmp_pin_obj.pin_address.replace(/\\/g, '');

        $pin_lat        = bmp_pin_obj.pin_lat;
        $pin_long       = bmp_pin_obj.pin_long;
        $pin_icon       = bmp_pin_obj.icon;
        $pin_title      = bmp_pin_obj.pin_title.replace(/\\/g, '');
        $pin_title      = $pin_title.replace(/'/g, '&#39' );
        $pin_title      = $pin_title.replace(/"/g, '&#34' );

        $pin_desc       = bmp_pin_obj.pin_desc.replace(/\\/g, '');
        $pin_desc       = $pin_desc.replace(/bmp_nl/g, '<br/>');    
        $pin_desc       = $pin_desc.replace(/'/g, '&#39' );
        $pin_desc       = $pin_desc.replace(/"/g, '&#34' );

        var $pin_row        = bmpX('<tr/>').attr('data-id', $pin_id).attr('id', 'pin_' + $pin_id );
        var $pin_td_name    = bmpX('<td/>').text( $pin_name );
        var $pin_td_address = bmpX('<td/>').text( $pin_address );
        var $pin_lat_long   = bmpX('<td/>').text($pin_lat + ' || ' + $pin_long );
        var $pin_td_icon    = bmpX('<td/>').append( "<img style='cursor:pointer;' id='bmp_pin_image' data-toogle='tooltip' data-html='true' data-placement='left' " +
                                                " title='" + $pin_title + "<hr/>" + $pin_desc + "' width='28' height='28'  src='" + bmpIconsDefaultUrl + "pin-" + $pin_icon + ".png' />" );
        var $pin_td_actions = bmpX('<td/>').append( '<button type="button" data-id='+ $pin_id + ' onclick="BmpEditPin(this);"  id="edit_bmp_pin" class="btn btn-success edit-bmp-map"> ' +
                                                    '<i class="fa fa-edit"></i> </button>' +
                                                    ' <button type="button" data-id=' + $pin_id + ' onclick="BmpDeletePin(this);"  id="delete_bmp_pin" class="btn btn-danger delete-bmp-map"> ' +
                                                 '<i class="fa fa-trash-alt"></i> </button>' );


        $pin_row.append( $pin_td_name );
        $pin_row.append( $pin_td_address );
        $pin_row.append( $pin_lat_long );
        $pin_row.append( $pin_td_icon );
        $pin_row.append( $pin_td_actions );

        if( action === 'prepend' )
            obj_to_prepend.prepend( $pin_row );  
        else
            obj_to_prepend.insertAfter( $pin_row );
        
        bmpX('#bmp_pin_image').tooltip();
    }
}

function Bmp_Encode_Str( rawStr ){
    var encodedStr = rawStr.replace(/[\u00A0-\u9999<>\&]/gim, function(i) {
        return '&#'+i.charCodeAt(0)+';';
    });
    return encodedStr;
}


function RefreshMapPin(){
    
    if( bmpX('#bmp_admin_show_pin').length > 0 ){ 
        var bmp_api_key     = bmpDataApiKey.trim(); 
        var mapRequest      = "https://www.bing.com/api/maps/mapcontrol?key="+ bmp_api_key + "&callback=bmp_admin_load_map_pin";
        CallRestService( mapRequest, bmp_admin_load_map_pin );

    }   
}

function CallRestService(request) {
            
    var script = document.createElement("script");
    script.setAttribute("type", "text/javascript");
    script.setAttribute("src", request);
    document.body.appendChild(script);
    
}

function bmp_admin_load_map_pin(){
    var bmp_admin_show_map      = document.getElementById('bmp_admin_show_pin'); 
        bmp_admin_show_map.style.width = '100%';
        bmp_admin_show_map.style.height = '400px';
    var bmp_pin_selected = parseInt( bmpX('#bmp_new_pin_icon option:selected').val() );
    var bmp_pin_lat     = bmpX('#bmp_new_pin_lat').val().trim();
    var bmp_pin_long    = bmpX('#bmp_new_pin_long').val().trim();
    var bmp_pin_title   = bmpX('#bmp_new_pin_title').val();
    var bmp_pin_desc    = bmpX( '#bmp_new_pin_description').val();
    var bmp_pin_img_src = bmpX('#pin_icon_img img').attr('src');
    var bmp_map_zoom    = parseInt( bmpX('#bmp_map_zoom').val() );

    bmp_pin_lat     = ( bmp_pin_lat.length > 0 ) ? bmp_pin_lat : '54.5260';
    bmp_pin_long     = ( bmp_pin_long.length > 0 ) ? bmp_pin_long : '15.2551';  
        

    
    bmp_bing_map_pins = new Microsoft.Maps.Map( bmp_admin_show_map, {
        center: new Microsoft.Maps.Location( bmp_pin_lat, bmp_pin_long ),
        zoom: bmp_map_zoom
    }); 

    if( bmp_pin_selected !== 0 && bmp_pin_lat.length > 0 && bmp_pin_long.length > 0 ){
        bmp_new_pin = new Microsoft.Maps.Pushpin( new Microsoft.Maps.Location(bmp_pin_lat, bmp_pin_long ),{
            icon : bmp_pin_img_src
        });
        pin.metadata = {
            title : bmp_pin_title,
            description : bmp_pin_desc
        };

        bmp_bing_map_pins.entities.push( bmp_new_pin );
    }

    Microsoft.Maps.loadModule('Microsoft.Maps.AutoSuggest', function () {
        var options = {
            maxResults: 4,
            map: bmp_bing_map_pins
          
        };
        var manager = new Microsoft.Maps.AutosuggestManager(options);
        manager.attachAutosuggest('#bmp_new_pin_address', '#searchBoxContainer', selectedSuggestion);
    });

    Microsoft.Maps.Events.addHandler( bmp_bing_map_pins, 'viewchangeend', function(e){        
        bmpX('#bmp_map_zoom').val( bmp_bing_map_pins.getZoom() );
    });

    function selectedSuggestion(suggestionResult) {
        bmp_bing_map_pins.entities.clear();
        bmp_bing_map_pins.setView({ bounds: suggestionResult.bestView });
        if( bmp_pin_selected !== 0 && bmp_pin_lat.length > 0 && bmp_pin_long.length > 0 ){
            bmp_new_pin = new Microsoft.Maps.Pushpin( new Microsoft.Maps.Location(bmp_pin_lat, bmp_pin_long ),{
                icon : bmp_pin_img_src
            });
            bmp_new_pin.metadata = {
                title : bmp_pin_title,
                description : bmp_pin_desc
            };
    
            bmp_bing_map_pins.entities.push( bmp_new_pin );
            bmp_bing_map_pins.setView({
                center: new Microsoft.Maps.Location(bmp_pin_lat, bmp_pin_long),
                zoom: bmp_map_zoom
            })
        }else{
            bmp_new_pin = new Microsoft.Maps.Pushpin(suggestionResult.location);
            bmp_bing_map_pins.entities.push(bmp_new_pin);
        }
        document.getElementById('bmp_new_pin_lat').value = suggestionResult.location.latitude;
        document.getElementById('bmp_new_pin_long').value = suggestionResult.location.longitude;

    }

}

function bmp_show_pin_on_map( bmp_pin_obj ){
    var bmp_pin_lat     = bmp_pin_obj.pin_lat;
    var bmp_pin_long    = bmp_pin_obj.pin_long;
    var bmp_pin_img_src = bmpIconsDefaultUrl +'pin-' + bmp_pin_obj.icon +'.png';
    var bmp_pin_title   = bmp_pin_obj.pin_title;
    var bmp_pin_desc    = bmp_pin_obj.pin_desc.replace(/\n|bmp_nl/g, '<br/>');
   // bmp_pin_desc        = bmp_pin_desc.replace(//g, '<br/>');
    bmp_pin_desc        = bmp_pin_desc.replace(/\\/g, '' );
    bmp_pin_title       = bmp_pin_title.replace(/\\/g, '' );
    
    var bmp_zoom        = bmpX('#bmp_map_zoom').val();

    if( bmp_pin_lat.length > 0 && bmp_pin_long.length > 0 ){
       
        bmp_bing_map_pins.entities.clear();

        bmp_new_pin = new Microsoft.Maps.Pushpin( new Microsoft.Maps.Location(bmp_pin_lat, bmp_pin_long ),{
            icon : bmp_pin_img_src
        });
        
        if( bmp_pin_title.length > 0 && bmp_pin_desc.length > 0 ){
            bmp_new_pin.metadata = {
                title : bmp_pin_title,
                description : bmp_pin_desc
            };

            infobox = new Microsoft.Maps.Infobox(bmp_bing_map_pins.getCenter(), {
                visible: false
            });

            infobox.setMap( bmp_bing_map_pins );
        }

        Microsoft.Maps.Events.addHandler(bmp_new_pin, 'click', pushpinClicked);

        bmp_bing_map_pins.entities.push( bmp_new_pin );

        bmp_bing_map_pins.setView({ center: new Microsoft.Maps.Location( bmp_pin_lat, bmp_pin_long ), zoom: bmp_zoom }); 
    }
}

function bmp_get_pin_data(){
    var pin_obj = {};
    pin_obj.pin_name    = bmpX('#bmp_new_pin_name').val().trim(); 
    pin_obj.pin_address = bmpX('#bmp_new_pin_address').val().trim();
    pin_obj.pin_lat     = bmpX('#bmp_new_pin_lat').val().trim();
    pin_obj.pin_long    = bmpX('#bmp_new_pin_long').val().trim();
    pin_obj.icon        = bmpX('#bmp_new_pin_icon option:selected').val();
    pin_obj.pin_title   = bmpX('#bmp_new_pin_title').val().trim();
    pin_obj.pin_desc    = bmpX('#bmp_new_pin_description').val().trim();

    return pin_obj;
}

function bmp_is_new_pin_changed(){
    var pin_obj = bmp_get_pin_data();
    var pin_icon = parseInt( bmpX('#bmp_new_pin_icon option:selected').val() );
    var aChanged = false;
    if( pin_obj.pin_name.length > 0 || pin_obj.pin_address.length > 0 || pin_obj.pin_lat.length > 0 || pin_obj.pin_long.length > 0 )
        aChanged = true;

    if( pin_obj.pin_title.length > 0 || pin_obj.pin_desc.length > 0 ||  pin_icon > 0 ) 
        aChanged = true;
        
    return aChanged;
}

function BmpEditPin( el ){
    var pin_id = el.getAttribute('data-id');
    if ( bmp_is_new_pin_changed() ){
        bmpX('#bmp_btn_edit_pin').attr('data-id', pin_id );
        bmpX('#bmp_modal_edit_pin').modal('show');             
    }else{                
        bmpX('#pin_action_id').val( pin_id );
        bmpX('#pin_action').val('edit-pin');
        bmpX('#bmp_cancel_edit_pin').show();
    
        bmpX('#bmp_pin_hidden_pin_id').val( pin_id );
        bmp_show_edited_pin( pin_id );   
    }
}


function bmp_show_edited_pin( pin_id  ){   
    var $edit_pin = bmp_get_pin_obj( pin_id );
  
    if( $edit_pin !== null ){
        bmp_update_pin_inputs( $edit_pin );
        bmp_show_pin_on_map( $edit_pin )

        if( ! bmpX('.new-pin-block').hasClass('show-new-pin-block') ){
            bmpX('#bmp_new_pin img').trigger('click');  
        }
    }
}


function bmp_get_pin_obj( $pin_id ){
    var $found = false;
    var $i = 0;
    var $pin_index = 0; 

    while( $i < bmpAllPins.length && ( ! $found ) ){
        if( bmpAllPins[$i].id == $pin_id ){
            $found = true;
            $pin_index = $i;
        }

        $i++;
    }
    
    if( $found ){
        return bmpAllPins[ $pin_index ];
    }else{
        return null;
    }
}

function bmp_update_pin_inputs( $pin_obj ){

    var pin_name, pin_address, pin_title, pin_desc;
    var newline = String.fromCharCode(13, 10);
    pin_name    = $pin_obj.pin_name.replace(/\\/g, '');
    pin_address = $pin_obj.pin_address.replace(/\\/g, '' );
    pin_title   = $pin_obj.pin_title.replace(/\\/g, '' );
    pin_desc    = $pin_obj.pin_desc.replace(/\\/g, '');
    
    pin_desc    = pin_desc.replace(/bmp_nl/g, newline );  

    bmpX('#bmp_new_pin_name').val( pin_name );
    bmpX('#bmp_new_pin_address').val( pin_address );
    bmpX('#bmp_new_pin_lat').val( $pin_obj.pin_lat );
    bmpX('#bmp_new_pin_long').val( $pin_obj.pin_long );
    bmpX('#bmp_new_pin_icon option').prop('selected', false );
    bmpX('#bmp_new_pin_icon #sel-' + $pin_obj.icon +' ' ).prop('selected', true);
    bmpX('#pin_icon_img img').attr('src', bmpIconsDefaultUrl + 'pin-' + $pin_obj.icon + '.png' );
    bmpX('#bmp_new_pin_title').val( pin_title);
    bmpX('#bmp_new_pin_description').val( pin_desc );  
   
}
